VERSION 5.00
Begin VB.Form frmMainMenu 
   Caption         =   "Orders Report Main Menu"
   ClientHeight    =   6330
   ClientLeft      =   1650
   ClientTop       =   1545
   ClientWidth     =   3510
   Icon            =   "MainMenu.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6330
   ScaleWidth      =   3510
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   855
      Left            =   600
      TabIndex        =   3
      Top             =   4800
      Width           =   2295
   End
   Begin VB.CommandButton cmdOrdersWithInvoices 
      Caption         =   "Orders not matching &invoices"
      Height          =   855
      Left            =   600
      TabIndex        =   2
      Top             =   3360
      Width           =   2295
   End
   Begin VB.CommandButton cmdOrdersNoInvoices 
      Caption         =   "&Orders without Invoices"
      Height          =   855
      Left            =   600
      TabIndex        =   1
      Top             =   1920
      Width           =   2295
   End
   Begin VB.CommandButton cmdGatherData 
      Caption         =   "&Gather Data"
      Height          =   855
      Left            =   600
      TabIndex        =   0
      Top             =   480
      Width           =   2295
   End
End
Attribute VB_Name = "frmMainMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public adoConnection As ADODB.Connection
Attribute adoConnection.VB_VarHelpID = -1

Private Sub adoConnection_ExecuteComplete(ByVal RecordsAffected As Long, _
                            ByVal pError As ADODB.Error, _
                            adStatus As ADODB.EventStatusEnum, _
                            ByVal pCommand As ADODB.Command, _
                            ByVal pRecordset As ADODB.Recordset, _
                            ByVal pConnection As ADODB.Connection)

    Debug.Print "In Execute Complete"
    Debug.Print pError.Description
    Debug.Print "Status = " & adStatus
    
End Sub

Private Sub adoConnection_WillExecute(Source As String, _
            CursorType As ADODB.CursorTypeEnum, _
            LockType As ADODB.LockTypeEnum, _
            Options As Long, _
            adStatus As ADODB.EventStatusEnum, _
            ByVal pCommand As ADODB.Command, _
            ByVal pRecordset As ADODB.Recordset, _
            ByVal pConnection As ADODB.Connection)

    Debug.Print "About to execute " & Source
    Debug.Print "Connection = " & pConnection.ConnectionString
    
End Sub


Private Sub cmdExit_Click()

    Unload Me
    
End Sub

Private Sub cmdGatherData_Click()

    Dim adoError As ADODB.Error
    
    Dim sqlStmt As String, strMsg As String
    
    On Error GoTo cmdGatherData_Click_Error
    
    Me.MousePointer = vbHourglass
'
' Tidy Up
'
10  sqlStmt = "Drop Table JPOrders"
    adoConnection.Execute sqlStmt, , adExecuteNoRecords
    sqlStmt = "Drop Table JPInvoiceTotals"
    adoConnection.Execute sqlStmt
    sqlStmt = "Drop Table JPInvoiceOrders"
    adoConnection.Execute sqlStmt
    sqlStmt = "Drop Table JPOrdersOnly"
    adoConnection.Execute sqlStmt

'
' This file will hold a combination of approved orders, along with dealer name and franchise code
'
20  sqlStmt = "Create  Table JPOrders " & _
                "(Name VarChar(40), UserId VarChar(20), UsOrderStatusCode VarChar(5) Not Null, PlanCode VarChar2(10), " & _
                "OrderDate Date, OrderAmount Number(17,2), NumUnits Int, FranchiseCode Int Not Null, DealerBPId Char(20), " & _
                "OrderNumber Number Not Null)"
    adoConnection.Execute sqlStmt

'
' When the above table is created, this table will be populated with invoices that have matching approved
' invoices.  The reason we are doing this is that orders should go to COMPLETE when we create invoices.
'
    sqlStmt = "Create Table JPInvoiceTotals " & _
                "(OrderNumber Number Not Null, InvoicedAmount Number(19,2) Not Null)"

    adoConnection.Execute sqlStmt
'
' This table will hold details about the orders where the invoice amount and order amount differ
'
    sqlStmt = "Create Table JPInvoiceOrders " & _
                "(OrderNumber Number Not Null, InvoicedAmount Number(19,2) Not Null, OrderDate Date, " & _
                "OrderAmount Number(17, 2) Not Null, NumUnits Number Not Null, FranchiseCode Int, " & _
                "DealerBPId Char(20) Not Null, Difference Number (17,2) Not Null, Name VarChar(40)," & _
                "UserId VarChar(20))"
    adoConnection.Execute sqlStmt
         
'
' This file will hold a combination of approved orders, along with dealer name and franchise code
'
    sqlStmt = "Create  Table JPOrdersOnly " & _
                "(Name VarChar(40), UserId VarChar(20), UsOrderStatusCode VarChar(5) Not Null, PlanCode VarChar2(10), " & _
                "OrderDate Date, OrderAmount Number(17,2), NumUnits Int, FranchiseCode Int Not Null, DealerBPId Char(20), " & _
                "OrderNumber Number Not Null)"
    adoConnection.Execute sqlStmt
    
'
' Use USORDERS as the driving table (Status of 01 is approved, see table USORDERSTATUS), get additional
' information from BPMaster (Customers Name) and Franchise (Orders has the franchise code, Franchise will
' point us to the BP).
'
    sqlStmt = "Insert Into JPOrders " & _
                "SELECT BPMASTER.NAME, USORDER.USERID, USORDER.USORDERSTATUSCODE, USORDER.PLANCODE, " & _
                    "USORDER.ORDERDATE, USORDER.ORDERAMOUNT, USORDER.NUMUNITS, FRANCHISE.FRANCHISECODE, " & _
                    "FRANCHISE.DealerBPId , USORDER.ORDERNUMBER " & _
                "FROM (USORDER INNER JOIN FRANCHISE ON (USORDER.FRANCHISECODE = FRANCHISE.FRANCHISECODE) " & _
                    "AND (USORDER.COUNTRYCODE = FRANCHISE.COUNTRYCODE) AND (USORDER.CLIENTID = FRANCHISE.CLIENTID)) " & _
                "INNER JOIN BPMASTER ON (FRANCHISE.DEALERBPID = BPMASTER.BPIDENTIFIER) AND (" & _
                    "USORDER.COUNTRYCODE = BPMASTER.COUNTRYCODE) AND (USORDER.CLIENTID = BPMASTER.CLIENTID) " & _
                "WHERE (((USORDER.USORDERSTATUSCODE)='01')) " & _
                "ORDER BY BPMASTER.NAME, USORDER.ORDERDATE"
    adoConnection.Execute sqlStmt

'
' Use the above table to search for invoices.  Technically there shouldn't be any, as an order should
' go to complete after the invoice has been created.  This happens when the invoice amount does not match
' the order amount.  There are many invoices per order, so it is necessary to total the invoice amounts which
' we will use later on in a report.
'
    sqlStmt = "Insert Into JPInvoiceTotals " & _
                "SELECT CONSIGNMENTINVOICE.ORDERNUMBER, Sum(CONSIGNMENTINVOICE.FINANCEDAMOUNT) AS InvoicedAmount " & _
                "FROM CONSIGNMENTINVOICE INNER JOIN JPORDERS ON CONSIGNMENTINVOICE.ORDERNUMBER = JPORDERS.ORDERNUMBER " & _
                "GROUP BY CONSIGNMENTINVOICE.ORDERNUMBER"
    adoConnection.Execute sqlStmt

'
' Build a table showing the orders and invoices, where the order amount and the invoiced amount are different
'
    sqlStmt = "Insert Into JPInvoiceOrders " & _
                "SELECT JPINVOICETOTALS.ORDERNUMBER, JPINVOICETOTALS.INVOICEDAMOUNT, JPORDERS.ORDERDATE, " & _
                    "JPORDERS.ORDERAMOUNT, JPORDERS.NUMUNITS, JPORDERS.FRANCHISECODE, JPORDERS.DEALERBPID, " & _
                    "JPOrders.OrderAmount - JPInvoiceTotals.InvoicedAmount AS Difference, JPOrders.NAME, " & _
                    "JPORDERS.USERID " & _
                "FROM JPINVOICETOTALS INNER JOIN JPORDERS ON JPINVOICETOTALS.ORDERNUMBER = JPORDERS.ORDERNUMBER " & _
                "Where (JPORDERS.ORDERAMOUNT <> JPINVOICETOTALS.InvoicedAmount) " & _
                "Order By DealerBPId "
    adoConnection.Execute sqlStmt

'
' This table will show the orders that do not have any invoices
'
    sqlStmt = "Insert Into JPOrdersOnly " & _
                "SELECT JPORDERS.Name, JPORDERS.USERID, JPORDERS.USORDERSTATUSCODE, JPORDERS.PLANCODE, " & _
                    "JPORDERS.ORDERDATE, JPORDERS.ORDERAMOUNT, JPORDERS.NUMUNITS, JPORDERS.FRANCHISECODE, " & _
                    "JPORDERS.DealerBPId , JPORDERS.ORDERNUMBER " & _
                "FROM JPORDERS LEFT JOIN JPINVOICETOTALS ON JPORDERS.ORDERNUMBER = JPINVOICETOTALS.ORDERNUMBER " & _
                "Where ((JPINVOICETOTALS.ORDERNUMBER) Is Null) " & _
                "Order By DealerBPId"
    adoConnection.Execute sqlStmt
    
    Me.MousePointer = vbNormal
    
    Exit Sub
    
cmdGatherData_Click_Error:
    If Erl = 10 And Mid$(Err.Description, 1, 9) = "ORA-00942" Then
        Resume Next
    End If
    
    Call ErrorMessage(Me.Caption & " - Gather Data")
        
    For Each adoError In adoConnection.Errors
        strMsg = strMsg & "ADO Error = " & adoError.Number & Chr$(13) & _
                    "Description = " & adoError.Description & Chr$(13) & _
                    "SQL State = " & adoError.SQLState & Chr$(13) & _
                    "Native Error = " & adoError.NativeError & Chr$(13) & _
                    "Source = " & adoError.Source
                    
    Next
    
    MsgBox strMsg

    Me.MousePointer = vbHourglass
    
End Sub

Private Sub cmdOrdersNoInvoices_Click()

    Dim adoShapeConnection As ADODB.Connection
    Dim adrRpt As ADODB.Recordset
    
    Dim objIni As Utilities.clsWinAndIni
    
    Dim sqlStmt As String
    
    Set objIni = New Utilities.clsWinAndIni
    
    Set adoShapeConnection = New ADODB.Connection
    With adoShapeConnection
        .ConnectionString = objIni.BuildConnectionString("x", "y", appDbIni, "SHAPE")
        .CursorLocation = adUseServer
        .Open
    End With
    
    sqlStmt = "Shape {Select distinct FranchiseCode, DealerBPId, Name " & _
                "From JPOrdersOnly} " & _
                "Append ({Select OrderNumber, OrderDate, PlanCode, " & _
                    "NumUnits, OrderAmount, UserId, " & _
                    "FranchiseCode " & _
                    "From JPOrdersOnly " & _
                        "Order By FranchiseCode, DealerBPId, OrderDate} " & _
                "Relate 'FranchiseCode' To 'FranchiseCode') " & _
                    " As Orders"
    
    Set adrRpt = New ADODB.Recordset
    With adrRpt
        .ActiveConnection = adoShapeConnection
        .Source = sqlStmt
        .CursorLocation = adUseClient
        .CursorType = adOpenForwardOnly
        .CacheSize = 1
        .Open , , , , adCmdText
    End With
    
    Set rptOrdersWithoutInvoices.DataSource = adrRpt

    Select Case UCase(objIni.GETINI("Reports", "Orders Without Invoices", appIni))
        Case "SHOW"
            rptOrdersWithoutInvoices.Show
        Case "PRINT"
            rptOrdersWithoutInvoices.PrintReport False, rptRangeAllPages
        Case "EXPORT"
            rptOrdersWithoutInvoices.ExportReport , "C:\Temp\Orders Without Invoices", True, True, rptRangeAllPages
        Case Else
            rptOrdersWithoutInvoices.Show
    End Select
    DoEvents
    
    adrRpt.Close
    adoShapeConnection.Close
    
    Set adrRpt = Nothing
    Set adoShapeConnection = Nothing
    

End Sub

Private Sub cmdOrdersWithInvoices_Click()

    Dim adoShapeConnection As ADODB.Connection
    Dim adrRpt As ADODB.Recordset
    
    Dim objIni As Utilities.clsWinAndIni
    
    Dim sqlStmt As String
    
    Set objIni = New Utilities.clsWinAndIni
    
    Set adoShapeConnection = New ADODB.Connection
    With adoShapeConnection
        .ConnectionString = objIni.BuildConnectionString("x", "y", appDbIni, "SHAPE")
        .CursorLocation = adUseServer
        .Open
    End With
    
    sqlStmt = "Shape {Select distinct FranchiseCode, DealerBPId, Name " & _
                "From JPInvoiceOrders} " & _
                "Append ({Select OrderNumber, OrderDate, InvoicedAmount, " & _
                    "NumUnits, OrderAmount, Difference, " & _
                    "FranchiseCode " & _
                    "From JPInvoiceOrders " & _
                        "Order By FranchiseCode, DealerBPId, OrderDate} " & _
                "Relate 'FranchiseCode' To 'FranchiseCode') " & _
                    " As Orders"
    
    Set adrRpt = New ADODB.Recordset
    With adrRpt
        .ActiveConnection = adoShapeConnection
        .Source = sqlStmt
        .CursorLocation = adUseClient
        .CursorType = adOpenForwardOnly
        .CacheSize = 1
        .Open , , , , adCmdText
    End With
    
    Set rptOrdersWithInvoices.DataSource = adrRpt

    Select Case UCase(objIni.GETINI("Reports", "Orders With Invoices", appIni))
        Case "SHOW"
            rptOrdersWithInvoices.Show
        Case "PRINT"
            rptOrdersWithInvoices.PrintReport False, rptRangeAllPages
        Case "EXPORT"
            rptOrdersWithInvoices.ExportReport , "C:\Temp\Orders Without Invoices", True, True, rptRangeAllPages
        Case Else
            rptOrdersWithInvoices.Show
    End Select
    DoEvents
    
    adrRpt.Close
    adoShapeConnection.Close
    
    Set adrRpt = Nothing
    Set adoShapeConnection = Nothing

End Sub


Private Sub Form_Load()

    Dim objIni As Utilities.clsWinAndIni
    
    Set objIni = New Utilities.clsWinAndIni
    
    Dim intCnt As Integer
    
    Set adoConnection = New ADODB.Connection
    
    With adoConnection
        .ConnectionString = objIni.BuildConnectionString("x", "y", appDbIni)
        .CursorLocation = adUseServer
        .Mode = adModeReadWrite
        .IsolationLevel = adXactCursorStability
        .Open
    End With
    
    Set objIni = Nothing
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    adoConnection.Close
    
    Set adoConnection = Nothing
    
End Sub


